from app import hashids, socketio
from app.decorators import socketio_login_required
from app.models import User
from flask_login import current_user
from flask_socketio import join_room


###############################################################################
# Socket.IO event handlers                                                    #
###############################################################################
@socketio.on('users.user.get')
@socketio_login_required
def users_user_get(user_hashid):
    user_id = hashids.decode(user_hashid)
    user = User.query.get(user_id)
    if user is None:
        response = {'code': 404, 'msg': 'Not found'}
    elif not (user == current_user or current_user.is_administrator):
        response = {'code': 403, 'msg': 'Forbidden'}
    else:
        response = {
            'code': 200,
            'msg': 'OK',
            'payload': user.to_dict(backrefs=True, relationships=True)
        }
        join_room(f'users.{user.hashid}')
    return response
